/* /////////////////////////////////////////////////////////////////////////////
 * File:        cstring_range_test.cpp
 *
 * Purpose:     Implementation file for the cstring_range_test project.
 *
 * Created:     17th May 2004
 * Updated:     19th March 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright 1999-2005, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* RangeLib Header Files */
#include <rangelib/rangelib.hpp>
#include <rangelib/algorithms.hpp>
#include <rangelib/cstring_range.hpp>

/* Standard C Header Files */

/* Standard C++ Header Files */
#include <iostream>

using std::cout;
using std::cerr;
using std::endl;

/* ////////////////////////////////////////////////////////////////////////// */

#if (   defined(WIN32) || \
        defined(_WIN32)) && \
    !defined(_INC_WINDOWS)
extern "C" void __stdcall Sleep(unsigned long);
#endif /* WIN32 */

/* ////////////////////////////////////////////////////////////////////////// */

struct dump_char
{
public:
	void operator ()(char const &ch)
	{
		cout << ch;
	}
};

/* ////////////////////////////////////////////////////////////////////////// */

int main(int argc, char *argv[])
{
#if 0
	::Sleep(100000);
#endif /* 0 */

    int                 iRet    =   0;
    int                 i;

	cout << "cstring_range_test: " << __STLSOFT_COMPILER_LABEL_STRING << endl;

	for(i = 1; i < argc; ++i)
	{
		const char	*arg	=	argv[i];

		if(arg[0] == '-')
		{
			if(arg[1] == '-')
			{
				/* -- arguments */
			}
			else
			{
				/* - arguments */
			}
		}
		else
		{
			/* other arguments */
		}
	}

	/* . */
	rangelib::cstring_range<char>	r("Lemon sherbert");

	cout << "Range: ";
		rangelib::r_for_each(r, dump_char());
	cout << endl;

	cout << "  Length of range: " << rangelib::r_distance(r) << endl;

	char const	ch	=	'e';

	cout << "  Number of " << ch << "'s in range: " << rangelib::r_count(r, 'e') << endl;

#if 0
	for(rangelib::cstring_range<char> r(; r; ++r)
	{
		cout << *r;
	}
#endif /* 0 */

    return iRet;
}

/* ////////////////////////////////////////////////////////////////////////// */
