/* /////////////////////////////////////////////////////////////////////////////
 * File:        compiler_traits_test.cpp
 *
 * Purpose:     Implementation file for the compiler_traits_test project.
 *
 * Created:     15th November 2003
 * Updated:     22nd April 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2003, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2003
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>

#include <stlsoft.h>
#include <stlsoft_compiler_traits.h>

#ifndef _STLSOFT_NO_NAMESPACE
using namespace stlsoft;
#endif /* !_STLSOFT_NO_NAMESPACE */

/* ////////////////////////////////////////////////////////////////////////// */

inline char const *bool_str_ptr(bool b)
{
	return b ? "true" : "false";
}

#if (   defined(WIN32) || \
        defined(_WIN32)) && \
    !defined(_INC_WINDOWS)
extern "C" void __stdcall Sleep(unsigned long);
#endif /* WIN32 */

/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

	int	const width	=	15;

	printf("compiler_traits_test: %s\n", __STLSOFT_COMPILER_LABEL_STRING);

	printf("\nEmpty Base class Optimisation (EBO):\n");

	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EBO1: ", bool_str_ptr(compiler_traits::supportsEBO1), sizeof(compiler_traits_ebo_thin_child), sizeof(compiler_traits_ebo_parent));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EBO2: ", bool_str_ptr(compiler_traits::supportsEBO2), sizeof(compiler_traits_ebo_thick_child), sizeof(compiler_traits_ebo_thick_peer));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EBO3: ", bool_str_ptr(compiler_traits::supportsEBO3), sizeof(compiler_traits_ebo_thin_grandchild), sizeof(compiler_traits_ebo_parent));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EBO4: ", bool_str_ptr(compiler_traits::supportsEBO4), sizeof(compiler_traits_ebo_thick_grandchild), sizeof(compiler_traits_ebo_thick_peer));
	printf("compiler supports %*s: %s\n", width, "EBO:  ", bool_str_ptr(compiler_traits::supportsEBO));

	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EBO5: ", bool_str_ptr(compiler_traits::supportsEBO5), sizeof(compiler_traits_ebo_mi_thin_child), sizeof(compiler_traits_ebo_parent));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EBO6: ", bool_str_ptr(compiler_traits::supportsEBO6), sizeof(compiler_traits_ebo_mi_thick_child), sizeof(compiler_traits_ebo_thick_peer));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EBO7: ", bool_str_ptr(compiler_traits::supportsEBO7), sizeof(compiler_traits_ebo_mi_mixin_child), sizeof(compiler_traits_ebo_thick_peer));
//	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EBO8: ", bool_str_ptr(compiler_traits::supportsEBO8),  );
	printf("compiler supports %*s: %s\n", width, "MIEBO: ", bool_str_ptr(compiler_traits::supportsMIEBO));
	printf("compiler supports %*s: %s\n", width, "ExtendedEBO: ", bool_str_ptr(compiler_traits::supportsExtendedEBO));

	printf("\nEmpty Derived class Optimisation (EDO)\n");

	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EDO1: ", bool_str_ptr(compiler_traits::supportsEDO1), sizeof(compiler_traits_ebo_thin_child), sizeof(compiler_traits_ebo_parent));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EDO2: ", bool_str_ptr(compiler_traits::supportsEDO2), sizeof(compiler_traits_edo_child<compiler_traits_edo_thin_base>), sizeof(compiler_traits_edo_thin_base));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EDO3: ", bool_str_ptr(compiler_traits::supportsEDO3), sizeof(compiler_traits_edo_child_of_thick_base), sizeof(compiler_traits_edo_thick_base));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EDO4: ", bool_str_ptr(compiler_traits::supportsEDO4), sizeof(compiler_traits_edo_child<compiler_traits_edo_thick_base>), sizeof(compiler_traits_edo_thick_base));
	printf("compiler supports %*s: %s\n", width, "EDO:  ", bool_str_ptr(compiler_traits::supportsEDO));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EDO5: ", bool_str_ptr(compiler_traits::supportsEDO5), sizeof(compiler_traits_ebo_mi_thin_child), sizeof(compiler_traits_ebo_parent));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EDO6: ", bool_str_ptr(compiler_traits::supportsEDO6), sizeof(compiler_traits_edo_mi_child<compiler_traits_edo_thin_base, compiler_traits_edo_thin_base2>), sizeof(compiler_traits_edo_thin_base));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EDO7: ", bool_str_ptr(compiler_traits::supportsEDO7), sizeof(compiler_traits_ebo_mi_mixin_child), sizeof(compiler_traits_ebo_thick_peer));
	printf("compiler supports %*s: %-5s - (%u, %u)\n", width, "EDO8: ", bool_str_ptr(compiler_traits::supportsEDO8), sizeof(compiler_traits_edo_mi_child<compiler_traits_edo_thick_base, compiler_traits_edo_thin_base>), sizeof(compiler_traits_edo_thick_base));
	printf("compiler supports %*s: %s\n", width, "MIEDO: ", bool_str_ptr(compiler_traits::supportsMIEDO));
	printf("compiler supports %*s: %s\n", width, "ExtendedEDO: ", bool_str_ptr(compiler_traits::supportsExtendedEDO));

	struct A
	{
		int	i;
	};
	struct X
		: A
	{};

	printf("sizeof(X): %u, sizeof(A): %u\n", sizeof(X), sizeof(A));

	struct B
	{};
	struct C
	{};

	struct Y
		: B, C
	{};

	printf("sizeof(Y): %u, sizeof(B) %u, sizeof(C): %u\n", sizeof(Y), sizeof(B), sizeof(C));

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
