/* /////////////////////////////////////////////////////////////////////////////
 * File:        glob_sequence_test.cpp
 *
 * Purpose:     Implementation file for the glob_sequence_test project.
 *
 * Created:     30th August 2005
 * Updated:     31st August 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright 1999-2005, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2005
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>
#include <stlsoft/simple_string.hpp>

#ifdef _WIN32
# define _STLSOFT_FORCE_ANY_COMPILER
#endif /* _WIN32 */

//#define UNIXSTL_GLOB_SEQUENCE_TRUST_ONLYDIR
//#define UNIXSTL_GLOB_SEQUENCE_DONT_TRUST_MARK

#include <unixstl.h>
#include <unixstl/glob_sequence.hpp>

#include <unixem/implicit_link.h>

/* Standard C++ Header Files */
#include <exception>
#include <iostream>

using std::cerr;
using std::cin;
using std::cout;
using std::endl;

#ifdef __WATCOMC__
namespace std
{
	using ::exception;
}
#endif /* __WATCOMC__ */


/* Standard C Header Files */

/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

/* ////////////////////////////////////////////////////////////////////////// */

static int main_(int /* argc */, char ** /*argv*/)
{
#if 0
	{ // 
		using unixstl::glob_sequence;

#if 0
#if 0
		glob_sequence	gls("~", "*", glob_sequence::directories | glob_sequence::noSort | glob_sequence::matchPeriod | glob_sequence::expandTilde);
#else /* ? 0 */
		glob_sequence	gls("~", "*", glob_sequence::directories | glob_sequence::noSort | glob_sequence::matchPeriod | glob_sequence::expandTilde | glob_sequence::markDirs /* | glob_sequence::includeDots */);
#endif /* 0 */

		for(glob_sequence::const_iterator b = gls.begin(); b != gls.end(); ++b)
		{
			fprintf(stdout, "\"%s\"", *b);

			if(!unixstl::filesystem_traits<char>::is_directory(*b))
			{
				fprintf(stdout, " is not a directory!"); 
			}

			fprintf(stdout, "\n");
		}
#else /* ? 0 */
		glob_sequence	gls("~", "*", glob_sequence::files | glob_sequence::noSort | glob_sequence::matchPeriod | glob_sequence::expandTilde);

		for(glob_sequence::const_iterator b = gls.begin(); b != gls.end(); ++b)
		{
			if(unixstl::filesystem_traits<char>::is_directory(*b))
			{
				fprintf(stderr, "\"%s\" is not a file!\n", *b); 
			}
		}
#endif /* 0 */
	}

	{ // Overloading test
		using unixstl::glob_sequence;

		static const char 		dir_cs[] = ".";
		static const char 		pat_cs[] = "*.*";

		std::string				dir_ss(".");
		std::string				pat_ss("*.*");

		stlsoft::simple_string	dir_sss(".");
		stlsoft::simple_string	pat_sss("*.*");

		int						flags	=	glob_sequence::noSort;

		glob_sequence	gls01(pat_cs);
		glob_sequence	gls02(pat_cs, flags);
		glob_sequence	gls03(dir_cs, pat_cs);
		glob_sequence	gls04(dir_cs, pat_cs, flags);

		glob_sequence	gls11(pat_ss);
		glob_sequence	gls12(pat_ss, flags);
#if !defined(STLSOFT_COMPILER_IS_BORLAND)
		glob_sequence	gls13(dir_ss, pat_ss);
		glob_sequence	gls14(dir_ss, pat_ss, flags);

		glob_sequence	gls21(pat_sss);
		glob_sequence	gls22(pat_sss, flags);
		glob_sequence	gls23(dir_sss, pat_sss);
		glob_sequence	gls24(dir_sss, pat_sss, flags);

		glob_sequence	gls31(dir_ss, pat_cs);
		glob_sequence	gls32(dir_sss, pat_cs);

		glob_sequence	gls41(dir_ss, pat_cs, flags);
		glob_sequence	gls42(dir_ss, pat_cs, flags);
#endif /* !STLSOFT_COMPILER_IS_BORLAND */

#if 0
		glob_sequence	gls51(dir_ss, pat_sss, flags);
		glob_sequence	gls52(dir_ss, pat_sss, flags);
#endif /* 0 */
	}
#else /* ? 0 */
	{ // Overloading test
		using unixstl::glob_sequence;

		static const char 		dir_cs[] = ".";
		static const char 		pat_cs[] = "*.*";

		std::string				dir_ss(".");
		std::string				pat_ss("*.*");

		stlsoft::simple_string	dir_sss(".");
		stlsoft::simple_string	pat_sss("*.*");

		int						flags	=	glob_sequence::noSort;

		glob_sequence	gls01("*");
		glob_sequence	gls02("*", glob_sequence::noSort);
		glob_sequence	gls04(dir_ss, "*", glob_sequence::noSort);
	}
#endif /* 0 */

    return 0;
}

int main(int argc, char *argv[])
{
#if 0
	{ for(size_t i = 0; i < 0xffffffff; ++i){} }
#endif /* 0 */

	try
	{
#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
		cout << "glob_sequence_test: " << __STLSOFT_COMPILER_LABEL_STRING << endl;
#endif /* debug */


		return main_(argc, argv);
	}
	catch(std::exception &x)
	{
		cerr << "Unhandled error: " << x.what() << endl;
	}
	catch(...)
	{
		cerr << "Unhandled unknown error" << endl;
	}

	return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
